#include "config.h"
#include <OctoPrintAPI.h>
#include <WiFiClient.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include "tunes.h"  

void playTune(int tuneNumber);

WiFiClient client;

String printerOperational;
String printerPaused;
String printerPrinting;
String printerReady;
String printerText;
String printerHotend;
String printerTarget;
String payload;

OctoprintApi api(client, OCTOPRINT_HOST, OCTOPRINT_PORT, OCTOPRINT_API_KEY);

bool displayOctoPrintVersion(Adafruit_SSD1306& display) {
    display.clearDisplay();
    display.setCursor(0, 0);
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.print("Fetching OctoPrint Version...");
    display.display(); // Show loading message

    // Attempt to fetch the OctoPrint version
    if (api.getOctoprintVersion()) {
        display.clearDisplay();
        display.setCursor(0, 0);
        display.setTextSize(1);
        display.setTextColor(WHITE);

        display.print("OctoPrint Version:");
        display.setCursor(0, 10);
        display.setTextSize(2); // Larger text for version
        display.print(api.octoprintVer.octoprintServer);

        display.display(); // Update the display
        playTune(2);
        return true; // Indicate success
    } else {
        display.clearDisplay();
        display.setCursor(0, 0);
        display.setTextSize(1);
        display.setTextColor(WHITE);
        display.print("Failed to get");
        display.setCursor(0, 10);
        display.print("OctoPrint version.");
        display.display();
        
        // Optionally, add a short delay to show the error
        playTune(3);
        return false; // Indicate failure
    }
    delay(1000);
}